// =================================================================== POSITIONS
struct position initPos(struct problem pb,
					 struct param param, struct quantum qAdapt)
{
	double c;
	int d;
	int deb;
	int i;
	int n;
	struct position pos;
	int s;
	double zz,zzz;

	pos.size=pb.SS.D;

	switch(param.init)
	{
		default: // 0. Uniform
			reInit:
				for (d = 0; d < pb.SS.D; d++)  
			{  
				pos.x[d] = alea (pb.SS.min[d], pb.SS.max[d]);
			}
				/*
				 if(pb.constraint==0) continue;
				 // Check constraints
				 ff=constraint(pos,pb.function,pb.epsConstr);
				 //printf("\ninit 27 ff"); for(d=1;d<ff.size;d++)	printf(" %f",ff.f[d]);	
				 // Just retry as long as all constraints are respected
				 // This is the most stupid method I am aware of
				 // but the simplest one to code
				 for(d=1;d<ff.size;d++) if(ff.f[d]>0) goto reInit;
				 */

		break;

		case 1: // Centre biased
			for (s = 0; s < param.S; s++)   
		{

			for (d = 0; d < pb.SS.D; d++)  
			{  
				zz=0.5*(pb.SS.max[d]+pb.SS.min[d]);
				if(alea(0,1)<0.5) pos.x[d]=zz*pow(alea(0,1),1./pb.SS.D);
				else pos.x[d]=zz*(2-pow(alea(0,1),1./pb.SS.D));
			}

		}
		break;

		case 2: // Improved Hammersley
			deb=alea_integer(0,pb.SS.D-1);

		for (s = 0; s < param.S; s++)   
		{
			pos=hammersley(pb.SS,param.S, deb,s);
			pos = quantis (pos, pb.SS);
		}
		break;

		case 3: // Random or Improved Hammersley	
			deb=alea_integer(0,pb.SS.D-1);
		for (s = 0; s < param.S; s++)   
		{
			if(alea(0,1)<0.5)
			{
				pos=hammersley(pb.SS,param.S, deb,s);
				pos = quantis (pos, pb.SS);
			}
			else
				for (d = 0; d < pb.SS.D; d++)  
			{  
				pos.x[d] = alea (pb.SS.min[d], pb.SS.max[d]);
			}
		}
		break;

		case 4: // 	Random/Regular	
			for (d = 0; d < pb.SS.D; d++)  
		{  
			pos.x[d] = floor(1+(pb.nb+1)*alea (pb.SS.min[d], pb.SS.max[d]))/(pb.nb+1);
		}
		break;

		case 5: // Centre biased 2
			for (s = 0; s < param.S; s++)   
		{
			for (d = 0; d < pb.SS.D; d++)  
			{  
				c=0.5*(pb.SS.min[d]+pb.SS.max[d]); // centre
				zz=alea (0, 1)-0.5; // Normalised distance to the centre
				zzz=(pb.SS.max[d]-pb.SS.min[d])*pow(fabs(zz),1+1./param.S); // decrease it

				if(zz>0)
					pos.x[d]=c+zzz; // re-add it
				else
					pos.x[d]=c-zzz;
			}
		}
		break;
		
		case 6: // On the boundaries
			for (d = 0; d < pb.SS.D; d++)  
			{  
				if(alea(0,1)<0.5) pos.x[d]=pb.SS.min[d];
				else pos.x[d]=pb.SS.max[d];
			}
				
		break;
		
				case 7: // On the boundaries and inside at random
		if(alea(0,1)<0.1)
		{
			for (d = 0; d < pb.SS.D; d++)  
			{  
				if(alea(0,1)<0.5) pos.x[d]=pb.SS.min[d];
				else pos.x[d]=pb.SS.max[d];
			}
		}
		else
			for (d = 0; d < pb.SS.D; d++)  
			{  
				pos.x[d] = alea (pb.SS.min[d], pb.SS.max[d]);
			}
				
		break;

		case 8: // In a non searched area
		pos=initFar(pb, param, qAdapt);
		break;
		
		case 14: // Special init for polygon problem
			zz=pi*2/(pb.SS.D+3); // delta theta
		i=1;
		for(d=1;d<pb.SS.D;d=d+2) // theta
		{
			pos.x[d]=zz*i;
			i=i+1;
		}

		n=(pb.SS.D+3)/2; // Number of sides	
		zz=(1-pi/n)/sin(pi*(n-2)/n);

		for(d=2;d<pb.SS.D;d=d+2) // rho
		{
			pos.x[d]=pi/4+zz*sin(pos.x[d-1]);
		}
		pos.x[0]=pi/n;

		break;
	}
	
	if(pb.SS.valueNb>0) // The search space is a list of acceptable values
	{
			pos=valueAccept(pos,pb.SS.valueNb) ;
	}
	return pos;
}
/*	
 // =============================================================
 struct velocity aleaVector(int D,double coeff)
 {
	 struct velocity V;
	 int d;
	 int i;
	 int K=2; // 1 => uniform distribution in a hypercube
	 // 2 => "triangle" distribution
	 double rnd;

	 V.size=D;

	 for (d=0;d<D;d++)
	 {								
		 rnd=0;
		 for (i=1;i<=K;i++) rnd=rnd+alea(0,1);		

		 V.v[d]=rnd*coeff/K;
	 }

	 return V;
 }
 */
//==================================================
struct position hammersley(struct SS SS, int N, int deb, int s)
{
	struct position x;
	double a;
	int d,D;
	int dd;
	int  kp;
	int pp;

	D=SS.D;
	// A sequence of prime numbers. You may modify it
	int P[100]={2,3,5,7,11, 13, 17, 19, 23, 29,
		31, 37, 41, 43, 47, 53, 59, 61, 67, 71,
		73,79,83,89,97,101,103,107,109,113,
		127,131,137,139,149,151,157,163,167,173,
		179, 181,191,193,197,199,211,223,227,229,
		233,239,241,251,257,263,269,271,277,281,
		283,293,307,311,313,317,331,337,347,349,
		353,359,367,373,379,383,389,397,401,409,
		419,421,431,433,439,443,449,457,461,463,
		467,479,487,491,499,503,509,521,523,541
	}; 
	double z;
	if(D>100) 
	{
		printf("\nDimension D = %i is too high\n",D);
		ERROR("You must increase the list of prime numbers");
	}
	x.size=D;
	x.x[deb]=SS.min[deb]+(SS.max[deb]-SS.min[deb])*(double)s/(N-1);
	dd=deb;
	for(d=1;d<D;d++) // for each dimension
	{				// compute the position
		dd=dd+1; if(dd>=D) dd=0;
		pp=P[dd];
		kp=s+1;
		z=0;
		while (kp>0)
		{
			a=kp % P[dd];     // kp modulo P[dd]
			z=z+(double)a/pp;
			kp=kp/P[dd]; // Integer division
			pp=pp*P[dd];
		}
		x.x[dd]=SS.min[dd]+z*(SS.max[dd]-SS.min[dd]);

	}
	//printf("\n2284 x\n"); for(d=0;d<D;d++) printf("%f ",x.x[d]);
	/*
	 fprintf(f_run,"\n");
	 for(d=0;d<D;d++)
	 fprintf(f_run,"%f ",(double)x.x[d]);
	 */
	return x;
}
// ================================================================== VELOCITIES
struct velocity initVel(int initVel, int SSize, struct problem pb, 
				struct position pos[],int s0)
{
		int d;
		int s1;
		
		struct velocity vel;		
		
			vel.size = pb.SS.D;
		switch(initVel)
	{
		default:

			for (d = 0; d < pb.SS.D; d++)  
			{				
				vel.v[d] =
					alea (pb.SS.min[d], pb.SS.max[d])-alea (pb.SS.min[d], pb.SS.max[d]);
			}
			break;


case 1: // Diff  (alea-X)
		case1:
			for (d = 0; d < pb.SS.D; d++)  
			{  
				vel.v[d] =alea(pb.SS.min[d], pb.SS.max[d])-pos[s0].x[d];
			}
			break;
			
		case 2: // xi - xj
		case2:
			s1=alea_integer(0,SSize-1); // Note that you may have s1 = s0
			for (d = 0; d < pb.SS.D; d++)  
			{  
				vel.v[d] =pos[s1].x[d]-pos[s0].x[d];
			}
			break;
		

		case 3: // zero
			for (d = 0; d < pb.SS.D; d++)  
			{				
				vel.v[d] = 0;
			}
			break;

			case 4:
			if(alea(0,1)<0.5) goto case1; else goto case2;

			case 5: // Half-diff  0.5*(alea-x)

			for (d = 0; d < pb.SS.D; d++)  
			{				
				vel.v[d] =
					(alea (pb.SS.min[d], pb.SS.max[d])-pos[s0].x[d])/2;
			}
			break;

			case 6: // Half-diff 0.5*(alea - alea)
			for (d = 0; d < pb.SS.D; d++)  
			{				
				vel.v[d] =
					0.5*(alea (pb.SS.min[d], pb.SS.max[d])-alea (pb.SS.min[d], pb.SS.max[d]));
			}
			break;
	}

	return vel;
}
// =========================================================== DISTRIBUTION METHODS
int initDistrib(int R)
{
		int distrib;
			
		switch(R)
	{
		default:
  		distrib =R;
			break;

		case 3:
			if(alea(0,1)<0.5 ) distrib=0; // Uniform
			else distrib=2; //  Decreasing function of the 1D distance
			break;

		case 5:
			if(alea(0,1)<0.5 ) distrib=0; // Uniform
			else distrib=4; // The evaluation will be "smoothed" (method 1)

		case 7:
			if(alea(0,1)<0.5 ) distrib=0; // Uniform
			else distrib=6; // The evaluation will be "smoothed" (method 2)
			break;

	}
		return distrib;
		}
// ================================================================ COEFFICIENTS
double initW(struct param param)
{
	double w;

	switch(param.W)
	{
		default: // Constant w
			w=param.w[0];
		break;

		case 1: // Random w (uniform) for some particles
			if(alea(0,1)<param.w0Rate)
			w=param.w[0]; 
		else w=param.w[1];
		break;

		case 2: // Random w (non-uniform) for some particles
			if(alea(0,1)<param.w0Rate) w=param.w[0]; 
		else
		{
			w=
				(alea(0,1)+alea(0,1))*(param.w[1]-param.w[0])+2*param.w[0]-param.w[1];
		}
		break;

		case 3: // Random w 
		if(param.w[0]>1./3) w=0.5*alea(3*param.w[0]-1,param.w[0]+1);
		else w=0.5*alea(param.w[0],3*param.w[0]);
		break;

		case 4: // Forced "scout" particle
			if(alea(0,1)<param.scout)
			w=alea(param.w[0],param.w[1]); 
		else
			w=param.w[0];

		break;
		
		case 5: // Random uniform + edge of chaos (c1 and c2 are depending on w)
		w=alea(param.w[0],param.w[1]);
		break;
	}
	return w;
}
// ===========================================
double initC1(struct param param, double w)
{
double c;


if(param.W==5)
{
	c=cEdge(w); 
}

switch(param.C1)
	{
		default: //  c
			c=param.c1;
		break;
		
		case 1: // Random uniform
			if(param.c1>1./3) c=0.5*alea(3*param.c1-1,param.c1+1);
		else c=0.5*alea(param.c1,3*param.c1);
		break;
		}

		return c;
	}
	// ===========================================
double initC2(struct param param, double w)
{
double c;

if(param.W==5)
{
 return cEdge(w); 
}

// ----------
switch(param.C2)
	{
		default: //  c
			c=param.c2;
		break;
		
		case 1:
			if(param.c2>1./3) c=0.5*alea(3*param.c2-1,param.c2+1);
		else c=0.5*alea(param.c2,3*param.c2);
		break;
}
		return c;
	}
	
	// ===========================================	
double cEdge(double w)
{

// Frontier of the complex domain (for the eigenvalues of the system)
//return (w+1+2*sqrt(w))/2; ;

// Frontier of the stability domain
return 0.999*w+1; //(w+1);

}
//==============================================================================
struct position initFar(struct problem pb, struct param param,
										struct quantum qAdapt)
{
	// Try to find a new position that is "far" from all the memorised ones

	//Note: memPos is a global variable
	double coord[MMax];
	int d;
	double delta;
	int init;
	double interv[2];
	int method=1; // 0 => stupid random method
								// 1 => look for the biggest empty hyperparallelepid
	int n;
	int nbGener;
	double pot, potFar;
	struct position X,XFar;

	//printf("\n initFar");
	switch(method)
	{
		default:
			// STUPID RANDOM METHOD
			nbGener=pb.SS.D*param.S; // Number of positions to generate
			init=param.init;
			param.init=0;
			XFar=initPos( pb,param,qAdapt);
			potFar=potentiel(XFar, memPos); 
			//printf("\n potFar %f",potFar);
			for(n=1;n<nbGener;n++)
		{
			X=initPos( pb,param,qAdapt);
			pot=potentiel(X, memPos);
			//printf("\n pot %f",pot);
			if(pot<potFar)
			{
				XFar=X;
				potFar=pot;
				//printf("\n pot %f",potFar);
			}
		}
			param.init=init;
			break;

		case 1:
			XFar.size=pb.SS.D;

			for(d=0;d<pb.SS.D;d++)
		{
//printf("\ninitFar 490 memPos.size %i coord:",memPos.size);
			for(n=0;n<memPos.size;n++) coord[n]=memPos.M[n].x[d];

			qsort(coord,memPos.size,sizeof(coord[0]),compareDoubles);
//printf("\n d %i coord ");for(n=0;n<10;n++) printf(" %f",coord[n]); 
			// Find the biggest intervall
			interv[0]=coord[0];
			interv[1]=coord[1];
			delta=interv[1]-interv[0];

			for(n=1;n<memPos.size-1;n++)
			{
				if(coord[n+1]-coord[n] < delta) continue;

				interv[0]=coord[n];
				interv[1]=coord[n+1];
				delta=interv[1]-interv[0];
			}

		XFar.x[d]=0.5*(interv[1]+interv[0]);
		
			if(pb.SS.max[d]-coord[memPos.size-1] > delta)
			{
						XFar.x[d]=pb.SS.max[d];
						delta=pb.SS.max[d]-coord[memPos.size-1]; 
			}
			
		if(coord[0]-pb.SS.min[d]> delta)
			{
						XFar.x[d]=pb.SS.min[d];
			}
			
		}
			break;
	}
	XFar=discrete(XFar, pb, param.quant,qAdapt);
	XFar.f=perf (XFar, pb, 0, 0, 0,param.normalise);
	XFar.forced=0;
	return XFar;

}

//============================================================
double potentiel(struct position X, struct archive list)
{
	double dist;
	int n;
	double pot=0;

	for(n=0;n<list.size;n++)
	{
		dist=distanceL(X,list.M[n],2);
		if(dist>zero) pot=pot+1./dist;
		else return infinity;	
	}

	return pot;

}