// Automatically evaluate some parameters whose value 
// is depending on the swarm size

param.p=1-pow(1-(double)1/(param.S),param.K);
// Note: for global best topology, directly set p to 1
//        and set orthoApply to any value you want (suggested: 5)

//if(param.initLink==4) param.p=2.0/param.S;	

 // Hard coded value for the number of iterations
// before restructuration
{
	eps=param.spreadProba;  // Probability to be informed
	if(eps<=zero) param.topolLinkNbMax=1;
	else
	switch(param.topology) // Depending on the topology
	{	
				default: // The case 3 still has to be analysed
			case 0: // SPSO 2007	
			param.topolLinkNbMax=(int)ceil(0.5+log(1-eps)/(param.K*log(1-1./param.S)));
		break;

		case 4: // Variable ring. Note that S is variable
			//param.topolLinkNbMax=(int)ceil(0.5+log(1-eps)/log(1-2./param.S));
			param.topolLinkNbMax=(int)ceil(0.5+(eps*param.S)/2);
		break;

		case 5: // Fixed ring 
			param.topolLinkNbMax=(int)ceil(0.5+(eps*param.S)/2);
					break;
	}
}

param.spread=param.topolLinkNbMax; //
param.orthoLearnApply=param.topolLinkNbMax;

//eps=1-param.spread; //0.25?;
 //(int)(0.5+log(eps)/log(1-param.p));
// After orthoApply iterations
// the probability that a given particle has been informed by any other one
// is 1-eps. There is no need to check stagnation before.
// Note: this formula is not really valid for "variable ring" topology
// hence the following one (rule of thumb):
if(param.topology==4) param.orthoLearnApply=param.S/4;	

param.orthoWalkApply= 1; //(int)(0.5+param.S/8); //  param.orthoLearnApply;

