struct GammaC variogram(struct position X[],int N,double xMini[DMax],double xMaxi[DMax])
{

 /*
	*******   WARNING **********
	In this version, the search space must be a hypercube
		
	*/

//------------------------------------------------------------------------------
//printf("\nvariogram 11");
 struct model c[modelMax];
 int d;
 int D;
 double Dist[MMax][MMax];
 struct GammaC Gamma;
 double distMax;
// int functionCode;
 double g[kMax];
 double h[kMax];
 double hDelta;
 int i,j,k;
 int kSup;
 int model;
 int modelNb;
 int nbK[kMax];
 double xMin,xMax;
 //struct position X[NMax];
// double zStar;
 double zz;	

 // Parameters
 kSup=10; 
 if(kSup>kMax) kSup=kMax;
 D=X[0].size; // Dimension

 //-----------
 // Temporary simplification
		/* WARNING
		 for the moment, we do suppose that the local search space
		 is a hypercube
		 */

 xMin=xMini[0]; xMax=xMaxi[0];
 for(d=1;d<D;d++)
 {
		if(xMini[d]<xMin) xMin=xMini[d];
		if(xMaxi[d]>xMax) xMax=xMaxi[d];
 }
//-----------
 hDelta=(xMax-xMin)*2./N; // Just a rule of thumb

 // Distance matrix
 for (i=0;i<N;i++)
 {
  for(j=i+1;j<N+1;j++)
  {
   Dist[i][j]=distanceL(X[i],X[j],2);
  }
 }
 
 // Max distance for the N points
 distMax=0;
 for (i=0;i<N-1;i++)
 {
  for (j=i+1;j<N;j++)
  {
   if(Dist[i][j]>distMax) distMax=Dist[i][j];
  }
 }
 
 //printf("\ndistMax %f",distMax);
 
 // Variogram estimation 
 // For different h values (kSup+1 classes)
 //  find the n(h) couples (x_i,x_j) for which  the distance is about equal to h
 //  and compute somme((f(x_i)-f(x_j))^2)/n(h)
 
 for(k=0;k<=kSup;k++) {g[k]=0; nbK[k]=0; h[k]=k*distMax/kSup;}
 
 for (i=0;i<N-1;i++)
 {
  for (j=i+1;j<N;j++)
  {
   for(k=0;k<=kSup;k++)
   {
	if(fabs(Dist[i][j]-h[k])<=hDelta)
	{
	 zz=X[i].f.f[0]-X[j].f.f[0];
	 g[k]=g[k]+zz*zz;
	 nbK[k]=nbK[k]+1;
	}			
   }	
  }
 }
 
 // Variogram
 for(k=0;k<=kSup;k++)
 {
  if(nbK[k]>0) 
  {
   g[k]=g[k]/nbK[k];
  }
 }
 
 /*
 for(k=0;k<=kSup;k++)
 {
  printf("\n %f %f %i",h[k],g[k],nbK[k]);
  fprintf(f_run,"%f %f \n",h[k],g[k]); // Save the variogram
 }
 */
 
 // Variogram model, gamma (function g(h) vs h)
 //0 Power
 //1 Exponential  (very rarely the best)
 //2 "Parabolic"
 //3 Beta distribution (very often the best)
 // (See modelG.c for details)
 
 
 modelNb=4;
 
 for(model=0;model<modelNb;model++) // For each model
 {
  //  find the best parameters
  c[model]=modelOptim(model,h,g,kSup);
	//printf("\nvariogram 119"); printf("\n");
 }
 
 // Choose the best model
 model=0;
 for(i=1;i<modelNb;i++)
 {
  if(c[i].error<c[model].error) model=i;
 }
/*
	// Display the best model
 switch(model)
 {
  case 0:
   printf("\nBest model = %i := %f*h^%f",model,c[0].c[0],c[0].c[1]);
   break;
  case 1:
   printf("\nBest model = %i := %f*(1-exp(-h/%f))",model,c[1].c[0],c[1].c[1]);
   break;
  case 2:
   printf("\nBest model = %i := %f*(1-(1-h/%f)^%f)",model,c[2].c[0],c[2].c[1],c[2].c[2]);
   break;
  case 3:
   zz=
	pow(c[3].c[0],c[3].c[0])*pow(c[3].c[1],c[3].c[1])
	*pow(hMax/(c[3].c[0]+c[3].c[1]),c[3].c[0]+c[3].c[1]);
   printf("\nBest model = %i := h^%f*(%f-h)^%e/%e",model,c[3].c[0],hMax,c[3].c[1],zz/gMax);
   break;
   
 }
*/ 

 // Matrix of variogram values gamma(x_i,x_j)
 Gamma.G.size=kSup+1;
 for (i=0;i<kSup;i++)
 {
  Gamma.G.m[i][i]=0;
  for (j=i+1;j<kSup;j++)
  {
   zz=Dist[i][j];
   Gamma.G.m[i][j]=modelG(zz,c[model]);
	 Gamma.G.m[j][i]=Gamma.G.m[i][j]; // Symmetrica
  }
 }
 
 // Complete by 1 last row and last column	
 for (i=0;i<kSup;i++)
 {
  Gamma.G.m[kSup][i]=1;
  Gamma.G.m[i][kSup]=1;
 }

  Gamma.G.m[kSup][kSup]=0;
 
 // Display the matrix
 //	matrixDisplay(Gamma.G);
 
 c[model].model=model;
 Gamma.c=c[model];
 
	return Gamma ;
}

// ===========================================================
void matrixDisplay(struct matrix M)
{
 register short i,j;
 
 printf("\n Matrix %ix%i",M.size,M.size);
 for (i=0;i<M.size;i++)
 {
  printf("\n");
  for (j=0;j<M.size;j++)
  {
   printf("%f ",(float)M.m[i][j]);
  }
 }
}
// ===========================================================
struct vector matrixSolve(struct matrix M,struct vector V)
{
 // Gauss pivot method
 struct vector b;
 double coef;
 int err;
 int i,j,k,l; 
 double max;
 int n;
 double pivot,s;
 double t[kMax][kMax+1];
 struct vector ZERO={0}; 
 ZERO.size=V.size;
 
 n=V.size;
 b.size=n;
 
 // Everything is put into t
 
 for(i=0;i<n;i++)
 {
  b.v[i]=V.v[i];
  for(j=0;j<n;j++)
   t[i][j]=M.m[i][j];
  
  t[i][n]=b.v[i];
 }

 err=1;
 k=0;
 while (err==1 && k<n-1)
 {
  max=fabs(t[k][k]);
  l=k;
  for(i=k+1;i<n;i++)
   if(max<fabs(t[i][k]))
  {
   max=fabs(t[i][k]);
   l=i;
  }
  if(max!=0)
  {
   if(l!=k)
	for(j=k;j<n+1;j++)
   {
	pivot=t[k][j];
	t[k][j]=t[l][j];
	t[l][j]=pivot;
   }
   pivot=t[k][k];
   for(i=k+1;i<n;i++)
   {
	coef=t[i][k]/pivot;
	for(j=k+1;j<n+1;j++)
	 t[i][j] -= coef*t[k][j];
   }
  }
  else err=0;
  k++;
 }
 if(t[n-1][n-1]==0) err=0;
 if(err==1)
 {
  b.v[n-1]=t[n-1][n]/t[n-1][n-1];
  for(i=n-2;i>=0;i--)
  {
   s=t[i][n];
   for(j=i+1;j<n;j++)
	s-=t[i][j]*b.v[j];
   b.v[i]=s/t[i][i];
  }
 }

 if(err==1)
 {
  //for(i=0;i<n;i++) b.v[i-1]=b.v[i];
  return b;
 }
 else
 {
   printf("\nERROR. Can't solve the system. I return a null vector");
  return ZERO;
 }	
} 
// ==========================================================
void vectorDisplay(struct vector V)
{
 int i;
 printf("\nVector length %i\n",V.size);
 for(i=0;i<V.size;i++) printf("%f ",(double)V.v[i]);
 
}
// ===========================================================
struct vector matrixVect(struct matrix M,struct vector V)
{
 // Product of a square matrix by a vector
 struct vector MV;
 register short i,j;
 
 MV.size=V.size;
 
 for(i=0;i<V.size;i++)
 {
  MV.v[i]=0;
  for(j=0;j<V.size;j++)
   MV.v[i]=MV.v[i]+M.m[i][j]*V.v[j];		
 }
 return MV;
}
// ===========================================================
#include "modelOptim.c"
