struct result PSO (struct param param, struct problem pb, int level) 
{  
	int added; // For information
	double c1,c2;
	int d; 
	struct fitness error={0}; 
	struct fitness errorI; 
	struct fitness errorInit; 
	struct fitness errorPrev;
	struct fitness errorBeforeIter;
	struct fitness f0;
	double eps;
	double errorTot;
	struct exploit ex;
	double explBestSize;

	double explRate[2];

	int g[SMax]; // Best informants
	int sBest; // Rank in g of the best of the bests
	int improvNb; // Number of successive improvements
	int improvTot; // NUmber of particles that have improved their previous best
	int index[SMax], indexTemp[SMax];     
	int initLinks;	// Flag to (re)init or not the information links
	int initLinkNb;
	int initLinkNbMax;
	int iterBegin;
	int j;
	int keep;
	struct krigin krigin;
	int length;
	int LINKS[SMax][SMax];	// Information links
	int m; 
	int moved;
	int n;	
	int noStop;
	double p;
	struct quantum qAdapt;
	struct result R={0};
	int rank;
	int removed; // For information
	double rho;
	int s0=0;
	int s,s1,s2; 
	int scanNb;
	int sInh;
	int stagnation;
	int strategy;
	int t;
	double tab[SMax];
	int updateRho;
	struct xv xv, xvNorm;
	double w;
	float z;
	double zz;

	//aleaV.size=pb.SS.D;

	// -----------------------------------------------------
	// INITIALISATION

	p=param.p; 				// Probability threshold for random topology
	R.SW.S = param.S; // Size of the current swarm
	memPos.rank=0; 					// Rank (in M) where to memorise a new position
	memPos.size=0; 					// Number of memorised positions

	// Positions
	if(param.init==-1) // Read from file 
	{
		f_init=fopen("f_initS20D30.txt","r"); // TO DO. The user should be in fact
		// asked for the name of the file
		// ***WARNING*** For the moment, NOT COMPATIBLE with the normalise option
		scanNb=	fscanf(f_init,"%i",&s0);
		if(s0!=R.SW.S)
		{
			printf("\nThe number of points (%i) in the file",s0);
			printf("\nis not consistent with the swarm size S (%i)",R.SW.S);
			ERROR(" ");
		}
		for (d = 0; d < pb.SS.D; d++)  
		{ 
			scanNb=fscanf(f_init,"%f",&z);
			R.SW.X[s].x[d]=z;		
		}
	}
	else
	{
		for (s = 0; s < R.SW.S; s++)   
		{
			R.SW.X[s]=initPos( pb,param,qAdapt);

			if(memo==1) 	// Memorise the positions
			{
				memPos.M[memPos.rank]=R.SW.X[s];

				if(memPos.size<MMax-1)
				{
					memPos.size=memPos.size+1;
					memPos.rank=memPos.rank+1;
				}
				else memPos.rank=0; // We re-use the memory cyclically. From now on, MSize=MMax
			}

		}
	}

	// Velocities and stagnation
	for (s = 0; s < R.SW.S; s++)
	{
		R.SW.V[s]=initVel(param.initVel,R.SW.S,pb, R.SW.X,s);	
		R.SW.stagn[s]=0;
	}

	// Distribution methods
	for (s = 0; s < R.SW.S; s++)   
	{
		R.SW.R[s]=initDistrib(param.R);
	}

	// Coefficients (different w and c)
	for (s = 0; s < R.SW.S; s++)   
	{
		R.SW.w[s]=initW(param);
		R.SW.c1[s]=initC1(param,R.SW.w[s]); 
		R.SW.c2[s]=initC2(param,R.SW.w[s]);	
	}

	// Strategy and stagnation
	m=0;n=0;
	for (s = 0; s < R.SW.S; s++)   
	{
		if(alea(0,1)<param.stratPop){m++; R.SW.strat[s]=param.strat[0];}
		else {n++;R.SW.strat[s]=param.strat[1];}
	}
	if(param.stratPop>0 && param.stratPop<1) // For each strategy, at least 
		// one particle
	{
		if(m==0) R.SW.strat[alea_integer(0,R.SW.S-1)]=param.strat[0];
		if(n==0) R.SW.strat[alea_integer(0,R.SW.S-1)]=param.strat[1];
	}

	// Neighbours
	for (s = 0; s < R.SW.S; s++)   
	{
		for(s1=0; s1<R.SW.S;s1++) 
		{
			R.SW.confid[s].plus[s1]=1;
			R.SW.confid[s].minus[s1]=1;
		}
	}

	// Prepare possible adaptive quantisation
	qAdapt=quantAdapt(R.SW, pb, param.quant);

	// Discrete values
	// Note: may be removed if you are sure that the initialisation
	//        takes discretisation into account (or if there is none)
	for (s = 0; s < R.SW.S; s++) 
	{
		R.SW.X[s]=discrete(R.SW.X[s], pb, param.quant,qAdapt);
	}

	// Note: at this point no confinement is needed:
	// initialisation is supposed to be OK from this point of view


	// First evaluations
	for (s = 0; s < R.SW.S; s++) 
	{	
		R.SW.X[s].f =
			perf (R.SW.X[s], pb, 0, 0, 0,param.normalise);

		R.SW.P[s] = R.SW.X[s];	// Best position = current one
		R.SW.P[s].improved = 0;	// No improvement
		R.SW.XPrev[s]=R.SW.X[s];
	}

	// If the number max of evaluations is smaller than 
	// the swarm size, just keep evalMax particles, and finish
	if (R.SW.S>pb.evalMax) R.SW.S=pb.evalMax;	
	R.nEval = R.SW.S;

	// Find the best and the worst
	// 	Remember that f is fabs(fitness-objective)
	// 	We want to minimise it
	R.SW.best = best(R.SW);
	R.SW.worst=worst(R.SW);
	errorPrev=R.SW.P[R.SW.best].f;

	errorInit=errorPrev; // Just for information
	error=errorPrev;


	// Display the best
	printf( "\n Best value after init. %f ", errorPrev.f[0] );
	if(pb.constraint>0)
	{
		printf("\n Constraints (should be < 0) ");
		for(n=0;n<pb.constraint;n++) printf("%f ",errorPrev.f[n+1]);
	}

	//fprintf(f_run,"\n Best value after init. %f ", errorPrev );
	//printf( "\n Position :\n" );
	//for ( d = 0; d < pb.SS.D; d++ ) printf( " %f", R.SW.P[R.SW.best].x[d] );

	initLinks = 1;		// So that information links will beinitialized
	// Note: It is also a flag saying "No improvement"
/*
	switch(param.initLinkNbMax)
	{
		default:initLinkNbMax=param.initLinkNbMax;
		break;
		case 0: initLinkNbMax=R.SW.S/2;
		break;
		case -1:    initLinkNbMax=2; //(int)(0.5/param.p);
		break;
	}
*/
initLinkNbMax=param.topolLinkNbMax;
	initLinkNb=0; // Number of iterations without checking if structural adaptation
	// is needed
	errorI=errorPrev;

	explRate[1]=param.force_LEA;
	explRate[0]=explRate[1]; // Previous exploitation rate
	improvNb=0;

	for(s=0;s<param.S;s++) index[s]=s; // For fixed topologies
	iter=0; iterBegin=0;
	nEval=0;
	noStop=0;
	rho=param.size_LEA;
	updateRho=0; // For adaptive LEA option
	added=0; removed=0; // For information

	// ---------------------------------------------- ITERATIONS
	while (noStop == 0) 
	{
		errorBeforeIter=error;

		//printf("\niter %i",iter);
		//fprintf(f_run,"\niter %i",iter); 
		iter=iter+1;

		if (initLinks==1)	// Random topology
		{
			initLinks=0;
			// Who informs who, at random
			switch(param.topology)
			{
				default:
					for (s = 0; s < R.SW.S; s++)
				{	
					for (m = 0; m < R.SW.S; m++)
					{		    
						if (alea (0, 1)<p) LINKS[m][s] = 1;	// Probabilistic method
						else LINKS[m][s] = 0;
					}
				}
					break;

				case 3: // Depending on "condifence"
					for (s = 0; s < R.SW.S; s++)
				{	
					for (m = 0; m < R.SW.S; m++)
					{		    
						//tab[m]=(double)R.SW.confid[s].plus[m]/R.SW.confid[s].minus[m];
						tab[m]=R.SW.confid[s].plus[m];
						LINKS[m][s] = 0;
					}

					for(m=0;m<param.K;m++)
					{
						new_t:
							t=aleaInformant(tab,R.SW.S);
							//	if(t==s) goto new_t;
							LINKS[t][s] = 1;
					}				
				}
					break;

					case 4: // Variable ring

						// Random permutation
						aleaIndex(index, R.SW.S);
					case 5: // Fixed ring	
						// Init to zero
						for (s = 0; s < R.SW.S; s++)
				{	
					for (m = 0; m < R.SW.S; m++)
					{		    
						LINKS[m][s] = 0;
					}
				}

		// Bidirectional ring	
			
					for (s = 0; s < R.SW.S-1; s++)
				{	
					LINKS[index[s]][index[s+1]] = 1;
					LINKS[index[s+1]][index[s]] = 1;		
				}
				
					LINKS[index[0]][index[R.SW.S-1]] = 1;
					LINKS[index[R.SW.S-1]][index[0]] = 1;

/*			// Unidirectional bi-ring	
					for (s = 0; s < R.SW.S-2; s++)
				{	
					LINKS[index[s]][index[s+1]] = 1;
					LINKS[index[s]][index[s+2]] = 1;		
				}
				
				LINKS[index[R.SW.S-2]][index[R.SW.S-1]] = 1;
				LINKS[index[R.SW.S-2]][index[0]] = 1;
				
				LINKS[index[R.SW.S-1]][index[0]] = 1;
				LINKS[index[R.SW.S-1]][index[1]] = 1;
*/
					break;


			}
			//fprintf(f_run,"\nendLinks");
			if(param.topolSelf==1)
			{
				// Each particle informs itself
				for (m = 0; m < R.SW.S; m++)
				{
					LINKS[m][m] = 1;	     
				}	
			}  
		}

		// Prepare the move. Initialisation of some variables
		//printf("\nIteration %i",iter);
		for (s = 0; s < R.SW.S; s++)
		{  
			index[s]=s;
			R.SW.Pp[s] = R.SW.P[s]; // Save the previous best, for information
			R.SW.lBest[s]=0; // Initialise the flags (for information)
			R.SW.X[s].forced=0; // Non "forced" move (for the moment)
			R.SW.P[s].forced=0;
		}

		explForced=0; // In order the evaluate the exploitation rate	

		// May define a random permutation of the particles	
		switch (param.randOrder)
		{
			default: // The same sequence for each iteration
				break;

			case 1: // Random permutation before each move of the swarm
				aleaIndex(index,R.SW.S);
			break;			
		}


		// Define the exploitation areas	
		ex=exploitArea(R.SW, pb.SS,param, updateRho, explRate,ex.rho); 

		// For information, size of the best local area
		sBest=R.SW.best;
		explBestSize=1;
		for(d=0;d<pb.SS.D;d++)
		{
			explBestSize=
				explBestSize*(ex.exI[g[sBest]].max[d]-ex.exI[g[sBest]].min[d]);
		}

		// Prepare adaptive quantisation...	
		// Note: it could be put _inside_ the loop on particls for (s0=...

		qAdapt=quantAdapt(R.SW, pb,param.quant);

		// Loop on particles, for move
		improvTot=0; 
		for (s0 = 0; s0 < R.SW.S; s0++)
		{			
			s=index[s0];
			xv.x.forced=0;
			moved=0;
			// Best informant
			g[s]=s;
		for (m = 0; m < R.SW.S; m++) 
				{	    
					if(m==s) continue;
					if (LINKS[m][s] == 1 && betterThan(R.SW.P[m].f,R.SW.P[g[s]].f)==1)
						g[s] = m;
				}	
			// May "force" a particle inside a LEA (local exploitation area)
			if(alea(0,1)<param.force_LEA)
			{
				switch(param.choose_LEA)
				{
					case 0: // Normal move
						break;

					case 1: // In the LEA of some particles
						xv=drawLEA(param, R.SW, s, g[s], ex, krigin );	
					break;

					case 2: // In the best local area
						if(R.SW.P[g[sBest]].forced==1 && param.draw_LEA==0)
						break; // Middle already sampled

					xv=drawLEA(param, R.SW, s, g[sBest], ex, krigin );
					R.SW.P[g[sBest]].forced=1; // Already used
				} // End of switch choose_LEA
			}

			// Inheritance of the coefficient values
			// Of course, it does make sense only if w, c1, c2 may be different
			// for each particle (see param.W, param.C1, param.C2)

			if(alea(0,1)<param.inheritance)  sInh=g[s]; 	
			else sInh=s;
			w=R.SW.w[sInh];
			c1=R.SW.c1[sInh];
			c2=R.SW.c2[sInh];

			strategy=R.SW.strat[s];

			// strategy=R.SW.strat[sInh]; 	// TO DO (to try) : inheritance of strategy 

			// Mutation of the coefficients
			// Note: hard-coded functions. Could be modified
			if(alea(0,1)<param.mutation[0]) w=min(max(w/2,alea_normal(w,w/param.S)),1);
			if(alea(0,1)<param.mutation[1]) c1=min(max(c1/2,alea_normal(c1,c1/param.S)),1.5*c1);
			if(alea(0,1)<param.mutation[2]) c2=min(max(c1/2,alea_normal(c2,c2/param.S)),1.5*c2);


			// Assign the coefficients
			R.SW.w[s]=w;
			R.SW.c1[s]=c1;
			R.SW.c2[s]=c2;

			// Memorise the previous fitness
			f0=R.SW.X[s].f;
			// Normal move (more precisely, non forced one)
			// It may be 
			// - a classical move 
			// - a "nearer is better" move
			// - a "orthogonal learning" move
			// - an "orthogonal walk"	

			move:
				//printf("\nPSO 442 strategy %i",strategy);
				switch(strategy)        // MOVE
			{
				default:
					xvNorm=move(R,s, g[s], pb, param, stagnation)	; 
					break;
					case 1: // Nearer is Better
						xvNorm=moveNisB(s, g[s], R.SW, pb, param);
					break;

					case 2: // Orthogonal Learning
						case -2: // + Factor Analysis
						xvNorm=moveOL(s, g[s], R.SW, pb, param, strategy, c1);
					break;

					case 3: // Orthogonal Walk
						xvNorm=moveOW(s, R.SW, pb, param,qAdapt);
					break;

					case 4: // pf-PSO (Ramana Murthy). Just for test
						xvNorm=movePF_PSO(R,s, g[s], pb, param, stagnation)	;  	
			}

				// If the first strategy is used just once ...
				if(param.stratOnce==1) R.SW.strat[s]=param.strat[1];

				// Discrete values
				if(xv.x.forced>0)
					xv.x=discrete(xv.x, pb, param.quant,qAdapt);

				xvNorm.x=discrete(xvNorm.x, pb, param.quant,qAdapt);		

			evaluate:
				// Confinement and evaluation
				if(xv.x.forced>0)
			{
				xv=confinement(xv,pb,param,R.SW.R[s]);
			}

				xvNorm=confinement(xvNorm,pb,param,R.SW.R[s]);

				// Modify the result. If forced, keep the best
				if(xv.x.forced==0) keep=0; // Normal move
				else
			{
				if(betterThan(xvNorm.x.f,xv.x.f)) keep=0; // There has been a forced move
				// but not better
				else keep=1; // Forced move is better
			}

				// Save the new position
				if(keep==0) 
			{
				R.SW.X[s]=xvNorm.x;
				R.SW.V[s]=xvNorm.v;
			}
				else
			{
				R.SW.X[s]=xv.x;
				R.SW.V[s]=xv.v;	
			}	

				// Update the best previous position
				if(betterThan(R.SW.X[s].f,R.SW.P[s].f)==1) // Improvement of the previous best
			{		
				R.SW.P[s] = R.SW.X[s];
				R.SW.P[s].forced=0; // Not used
				R.SW.stagn[s]=0;
				R.SW.confid[s].plus[g[s]]=R.SW.confid[s].plus[g[s]]+1;
				improvTot++;

				if(memo==1)
				{
					// Memorise the positions
					memPos.M[memPos.rank]=R.SW.X[s];

					if(memPos.size<MMax-1)
					{
						memPos.size=memPos.size+1;
						memPos.rank=memPos.rank+1;
					}
					else memPos.rank=0; // We re-use the memory cyclically 
				}

				// Update the best of the bests
				if(betterThan(R.SW.P[s].f,R.SW.P[R.SW.best].f)==1)
				{		
					R.SW.best = s;			
				}				
			}
				else
					R.SW.confid[s].minus[g[s]]=R.SW.confid[s].minus[g[s]]+1;	// Less confidence

				switch(param.stagType)
			{
				default: break;
				case 1:
					if(betterThan(R.SW.X[s].f,R.SW.XPrev[s].f)!=1) // No improvementof the current position
				{			
					R.SW.stagn[s]++;	
				}
					break;

				case 2:
					if(betterThan(R.SW.X[s].f,R.SW.P[s].f)!=1) // No improvement of the previous best
				{			
					R.SW.stagn[s]++;	
				}
					break;
			}

				// May try another strategy
				if(param.stagType==1 || param.stagType==2) 
			{ 
				if( R.SW.stagn[s]>=param.spread  )
				{
					R.SW.stagn[s]=0;
					R.SW.strat[s]=param.strat[1];
				}
				else R.SW.strat[s]=param.strat[0];
			}

				// If too many evaluations => STOP
				if (nEval >= pb.evalMax) 
			{
				printf("\n Max number of evaluations after %i iterations",iter);
				goto end;
			}	

				// May try the opposite
			{
				if(param.opposite==1 && moved==0 && betterThan(R.SW.X[s].f,f0)==0)
				{
					for (d = 0; d < pb.SS.D; d++)
					{	
						xvNorm.x.x[d] = R.SW.X[s].x[d]-2*R.SW.V[s].v[d];
						xvNorm.v.v[d]= -R.SW.V[s].v[d];
					}	
					xv.x.forced=0;
					moved=1; goto evaluate;
				}
			}

				// Save the previous position
				R.SW.XPrev[s]=R.SW.X[s];
				/*
				 // Memorise the  position
				 if(memo==1)
			 {
				 memPos.M[memPos.rank]=R.SW.X[s];

				 if(memPos.size<MMax-1)
				 {
					 memPos.size=memPos.size+1;
					 memPos.rank=memPos.rank+1;
				 }
				 else memPos.rank=0; // We re-use the memory cyclically 
			 }
				 */
				// Update the worst
				if(betterThan(R.SW.P[R.SW.worst].f,R.SW.P[s].f)==1)
			{		
				R.SW.worst = s;			
			}							
		}			// End of "for (s0=0 ...  "	


		// Exploitation rate (how many particles are in a LEA?) 
		explRate[0]=explRate[1]; // Save the previous one
		explRate[1]=explNb(R.SW,ex); 
		// Save it for further analysis
		if(param.explSave>0)
		{
			fprintf(f_expl, "explBestSize %f ",explBestSize);
			fprintf(f_expl,"explRate %f\n",explRate[1]);
		}

		updateRho=1; // To use in exploitArea in case of adaptive option,
		// supposed to "balance" exploitation/exploration

		// Check global stagnation 
		error = R.SW.P[R.SW.best].f;

		if (betterThan(error,errorPrev)==1) 
		{stagnation=0;	// Improvement
			improvNb++;
		}
		else 
		{
			stagnation++; // No improvement of the global best 
			improvNb=0;
		}


		// Check if improvement since last structural adaptation
		// Note: this is not exactly the same test as above	
		initLinkNb=initLinkNb+1;
		initLinks=0;
		if(initLinkNb>=initLinkNbMax)
		{
			initLinkNb=0;

			if (betterThan(error,errorPrev)==1)	// Improvement
			{	
				initLinks = 0;									
			}
			else			// No improvement
			{			
				initLinks = 1;	// Information links will be	reinitialized	
			}
		}

R.SW.worst=worst(R.SW); // Rank of the worst particle, before any adaptation
		if(param.swarmVar==1)
		{
			//	 fprintf(f_swarm,"%i %f\n",R.SW.S,error.f[0]);
			
			if(stagnation>=param.spread)  // If stagnation, add a particle
			{
				if(R.SW.S<SMax)
				{
					s=R.SW.S;
					//R.SW.X[s]=initPos(param.init,R.SW.S, pb);
					R.SW.X[s]=initFar(pb, param,qAdapt);
					R.SW.X[s].f = perf (R.SW.X[s], pb, 0, 0, 0,param.normalise);
					R.SW.V[s]=	R.SW.V[s]=initVel(param.initVel,R.SW.S,pb, R.SW.X,s);	

					R.SW.X[s].forced=0; 
					R.SW.lBest[s]=0;
					R.SW.w[s]=initW(param);
					R.SW.c1[s]=initC1(param,R.SW.w[s]); 
					R.SW.c2[s]=initC2(param,R.SW.w[s]);	
					R.SW.R[s]=initDistrib(param.R);
					for(s1=0; s1<R.SW.S;s1++) 
					{
						R.SW.confid[s].plus[s1]=1;
						R.SW.confid[s].minus[s1]=1;
					}
					R.SW.stagn[s]=0;
					R.SW.strat[s]=	param.strat[0];

					R.SW.P[s]=R.SW.X[s];								
					R.SW.Pp[s]=R.SW.X[s];								
					R.SW.XPrev[s]=R.SW.X[s];								
					R.SW.S=R.SW.S+1;
					param.S=R.SW.S;
					initLinks=1; // Links will be reinitialised
//printf("\nPSO 706 iter %i S %i  error %f",iter, R.SW.S,error.f[0]);	
fprintf(f_swarm,"%i %i  %f\n",iter, R.SW.S,error.f[0]);
					added++;
				}
			}
// If enough improvement, remove the worst
			//	if(R.SW.S>2 && stagnation==0) // remove A
			//if(R.SW.S>2 && improvNb>=param.spread) // remove B
//printf("\n PSO 713 S %i improvTot %i",R.SW.S, improvTot);
		//		if(R.SW.S>2 && improvTot==R.SW.S)		// remove C
	//if(R.SW.S>2 && improvTot==R.SW.S && improvNb>=param.spread )	// remove D	
			//if(R.SW.S>2 && improvTot>0) // remove E
			//	if(R.SW.S>2 && improvTot>R.SW.S/2) // remove F	
//	if(R.SW.S>2 && improvTot>R.SW.S/2 && improvNb>=param.spread )	// remove G
		if(R.SW.S>pb.SS.D+1 && improvTot>R.SW.S/2 )	// remove H	
//				if(R.SW.S>pb.SS.D+1 && improvTot>0 )	// remove I					
			{
				s=R.SW.worst;
				if(s<R.SW.S-1)
				{
					R.SW.P[s]=R.SW.P[R.SW.S-1];
					R.SW.Pp[s]=R.SW.Pp[R.SW.S-1];
					R.SW.lBest[s]=R.SW.lBest[R.SW.S-1];
					R.SW.V[s]=R.SW.V[R.SW.S-1];
					R.SW.X[s]=R.SW.X[R.SW.S-1];
					R.SW.XPrev[s]=R.SW.XPrev[R.SW.S-1];
					R.SW.w[s]=R.SW.w[R.SW.S-1];
					R.SW.c1[s]=R.SW.c2[R.SW.S-1];
					R.SW.R[s]=R.SW.R[R.SW.S-1];
					R.SW.confid[s]=R.SW.confid[R.SW.S-1];
					R.SW.stagn[s]=R.SW.stagn[R.SW.S-1];
					R.SW.strat[s]=R.SW.strat[R.SW.S-1];
	// Compact the matrix of the links
	
				for(s1=0;s1<R.SW.S;s1++)  // For each line, compact the columns
					for(s2=R.SW.worst;s2<R.SW.S-1;s2++) LINKS[s1][s2]=LINKS[s1][s2+1];

				for(s2=0;s2<R.SW.S-1;s2++)	// For each column, compact the lines
					for(s1=R.SW.worst;s1<R.SW.S-1;s1++) LINKS[s1][s2]=LINKS[s1+1][s2];	
			}
				R.SW.S=R.SW.S-1;
				if(s<R.SW.best) R.SW.best=R.SW.best-1; 
				param.S=R.SW.S;
		
			//printf("\nPSO 753 iter %i S %i  error %f",iter,R.SW.S,error.f[0]);
				fprintf(f_swarm,"%i %i  %f\n",iter, R.SW.S,error.f[0]);	
				removed++;
			}
			#include "paramAuto.c"	
		}

		if(param.stagType==3) // Modify the strategy of some particles
		{
			//printf("\nPSO 623 %i %i",stagnation, param.stagnation);
			if(stagnation>=param.spread) 
			{
				for(s=0;s<param.S;s++) R.SW.strat[s]=param.strat[0]; // Reinitialise
				for(s=0;s<param.S;s++) // Modify some strategies
				{
					if(alea(0,1)<param.stagRate) R.SW.strat[s]=param.strat[1];
				}
			}
		}

		if(param.stagType==3) // Reinitialise some particles
		{
			// At least one
			R.SW.X[R.SW.worst]=initFar(pb,param,qAdapt);
			for(s=0;s<param.S;s++)
			{
				if(s==R.SW.worst) continue;
				if(alea(0,1)<param.stagRate) 
				{ 
					m++;
					R.SW.X[s]=initPos(pb,param,qAdapt);
				}
			}  
		}


		// Case 0: update the links if there has been NO improvemnt
		// Case 1: the contrary
		if(param.topolInit==1) initLinks=1-initLinks;

		// Save error	
		errorI=error;
		errorPrev = error;

		// End of the iteration 
		//May be a "premature" end if there has been too many evaluations
		end:

			// Prepare the curve "success rate" vs FEmax
			// (for unconstrained optim.)
			if(error.f[0]<=pb.epsilon) 
		{				
			for(n=FEclass;n<FEmaxSize;n++)
				successFlag[run][n]=1;
		}

			if(nEval>FEmax[FEclass])
		{
			// Prepare the curve "mean best" vs FEmax
			bestS[run][FEclass]=error.f[0];	

			FEclass=FEclass+1;
		}

			// Decide to stop or not, depending on the chosen criterion
			switch (param.stop)
		{		
			case 0:
				errorTot=errorFC(error);

				if (errorTot > pb.epsilon && nEval < pb.evalMax)
					noStop = 0;	// Won't stop
				else // Failure
					noStop = 1;	// Will stop
				break;

			case 1:			
				if (nEval < pb.evalMax)
					noStop = 0;	// Won't stop
				else
					noStop = 1;	// Will stop
				break;		
		}

			// May reinitialise "bad" particles (i.e. selection)
			if(noStop==0 && param.select>0) 
		{	
			R.SW=swarmSelect(R.SW,param.select, pb,param,qAdapt);
		}
			/*		
			 // In case of variable w
			 if(param.W>0)
		 {
			 for (s = 0; s < R.SW.S; s++)   
			 {
				 R.SW.w[s]=initW(param);
				 R.SW.c1[s]=initC1(param,R.SW.w[s]); 
				 R.SW.c2[s]=initC2(param,R.SW.w[s]);	
			 }
		 }
			 */

	} // End of "while (noStop==0)"


	// printf( "\n and the winner is ... %i", R.SW.best );			
	// fprintf( f_stag, "\nEND" );

	// Convergence rate, just for information
	R.convRate=(errorInit.f[0]-error.f[0])/errorInit.f[0];

	// Information in case of variable swarm
	if(param.swarmVar==1)
	{
		printf("\n	particles: added %i, removed %i",added,removed);
	}
	// Final number of evaluations
	R.nEval=nEval;
	// Final fitness
	R.error = R.SW.P[R.SW.best].f;
	return R;  
}
//==============================================================================
int best(struct swarm SW)
{
	// Find the rank of the best position
	// 	Remember that f is fabs(fitness-objective)
	// 	We want to minimise it
	int s=0;
	int best = 0;

	for (s = 1; s < SW.S; s++)     
	{
		if(betterThan(SW.P[s].f,SW.P[best].f)==1)
			best = s;
	}
	return best;
}	
//==============================================================================
int worst(struct swarm SW)
{
	// Find the rank of the worst position
	int s=0;
	int worst = 0;

	for (s = 1; s < SW.S; s++)     
	{
		if(betterThan(SW.P[worst].f,SW.P[s].f)==1)
			worst = s;
	}
	return worst;
}	
