struct position modelFunctOptim (struct position X[],struct GammaC Gamma, double xMin[], double xMax[])
{

	// WARNING, in this version the search space must be a hypercube
	// (Just one xmin and and xmax)

	// Apply a simple PSO in order to find the best position of the surrogate function 
	//struct model modelOptimPSO (struct param ) 

	struct velocity aleaV; 
	static double c=0.721;
	int d;   
	int Dim;
	double error=0;   // Set to zero just for my stupid compiler 
	double errorPrev;
	int evalMax;
	int gg; 
	struct velocity GX;   
	// int index[SMax];
	//	int indexTemp[SMax];     
	int initLinks;	// Flag to (re)init or not the information links
	int iter; 		// Iteration number (time step)
	int iterBegin;
	// int length;
	int LINKS[SMax][SMax];	// Information links
	int m;
	int nEval;
	int noEval; 	
	int noStop;
	double p;
	struct velocity PX;	
	// struct model R={0};
	struct swarm SW;
	int  s,s1; 
	static double w=1.193;
	double zz;
	//printf("\nmodelFunctOptim 37"); printf("\n");
	Dim=X[0].size;
	evalMax=67*Dim+33; // Rule of thumb

	aleaV.size=Dim;
	// -----------------------------------------------------
	// INITIALISATION
	SW.S= (int) (10 + 2 * sqrt(Dim));
	p=1-pow(1-(double)1/(SW.S),3); // Probability threshold for random topology
	//printf("\nmodelFunctOptim S %i p %f", SW.S,p);
	// Position and velocity
	for (s = 0; s < SW.S; s++)   
	{ 
		SW.X[s].size = Dim;
		SW.V[s].size = Dim;

		for (d = 0; d < Dim; d++)  
		{  
			SW.X[s].x[d] = alea (xMin[d], xMax[d]); //alea (pb.SS.min[d], pb.SS.max[d]);
		}

		for (d = 0; d < Dim; d++)  
		{				
			SW.V[s].v[d] = 
				(alea( xMin[d], xMax[d] ) - SW.X[s].x[d])/2; 
		} 	
	}	
	//printf("\nmodelFunctOptim 65"); printf("\n");

	// First evaluations
	for (s = 0; s < SW.S; s++) 
	{		
		SW.X[s].f =  perfModelFunc(Gamma,SW.X[s],X);	
		SW.P[s] = SW.X[s];	// Best position = current one
	}
	//printf("\nmodelFunctOptim 72"); printf("\n");
	nEval = SW.S;

	// Find the best
	SW.best = 0;
	errorPrev = SW.P[SW.best].f.f[0];

	for (s = 1; s < SW.S; s++)     
	{
		zz=SW.P[s].f.f[0];
		if (zz < errorPrev)
			SW.best = s;
		errorPrev=zz;			
	}
	initLinks = 1;		// So that information links will beinitialized
	// Note: It is also a flag saying "No improvement"
	noStop = 0;	

	// ---------------------------------------------- ITERATIONS
	iter=0; iterBegin=0;
	while (noStop == 0) 
	{
		iter=iter+1;
		// Who informs who, at random
		for (s = 0; s < SW.S; s++)
		{	
			for (m = 0; m < SW.S; m++)
			{		    
				if (alea (0, 1)<p) LINKS[m][s] = 1;	// Probabilistic method
				else LINKS[m][s] = 0;
			}

			// Each particle informs itself
			for (m = 0; m < SW.S; m++)
			{
				LINKS[m][m] = 1;	     
			}	  
		}

		// The swarm MOVES
		//printf("\nIteration %i",iter);
		for (s = 0; s < SW.S; s++)	// For each particle ...
		{	

			// ... find the first informant
			s1 = 0;    
			while (LINKS[s1][s] == 0)	s1++;					
			if (s1 >= SW.S)	s1 = s;

			// Find the best informant			
			gg = s1;	
			for (m = s1; m < SW.S; m++) 
			{	    
				if (LINKS[m][s] == 1 && SW.P[m].f.f[0] < SW.P[gg].f.f[0])
					gg = m;
			}	

			//.. compute the new velocity, and move

			// Exploration tendency
			for (d = 0; d < Dim; d++)
			{
				SW.V[s].v[d]=w *SW.V[s].v[d];
			}

			// Prepare Exploitation tendency
			for (d = 0; d < Dim; d++)
			{
				PX.v[d]= SW.P[s].x[d] - SW.X[s].x[d];
			}				
			PX.size=Dim; 

			if(gg!=s)
			{
				for (d = 0; d < Dim; d++)
				{
					GX.v[d]= SW.P[gg].x[d] - SW.X[s].x[d];
				}
				GX.size=Dim;
			}

			// Apply tendencies			
			for (d = 0; d < Dim; d++)
			{	
				SW.V[s].v[d]=SW.V[s].v[d] +
					+	alea(0, c)*PX.v[d];
			}

			if (gg!=s)
			{
				for (d = 0; d < Dim; d++)
				{	
					SW.V[s].v[d]=SW.V[s].v[d] 
						+	alea(0,c) * GX.v[d];			
				}
			}						

			// Update the position
			for (d = 0; d < Dim; d++)
			{	
				SW.X[s].x[d] = SW.X[s].x[d] + SW.V[s].v[d];			
			}

			if (nEval >= evalMax) goto end;
			// --------------------------
			noEval = 1;

			// Set to the bounds, and v to zero
			for (d = 0; d < Dim; d++)
			{	
				if (SW.X[s].x[d] < xMin[d])
				{	
					SW.X[s].x[d] = xMin[d];
					SW.V[s].v[d] = 0;
				}

				if (SW.X[s].x[d] > xMax[d])
				{			
					SW.X[s].x[d] = xMax[d];
					SW.V[s].v[d] = 0;			
				}				
			}

			SW.X[s].f =  perfModelFunc(Gamma,SW.X[s],X);	
			nEval = nEval + 1;				

			// ... update the best previous position
			if (SW.X[s].f.f[0] < SW.P[s].f.f[0])	// Improvement
			{		
				SW.P[s] = SW.X[s];	
				// ... update the best of the bests
				if (SW.P[s].f.f[0] < SW.P[SW.best].f.f[0])
				{		
					SW.best = s;			
				}				
			}		
		}			// End of "for (s=0 ...  "	
		// Check if finished

		error = SW.P[SW.best].f.f[0];

		if (error < errorPrev)	// Improvement
		{		
			initLinks = 0;							
		}
		else			// No improvement
		{			
			initLinks = 1;	// Information links will be	reinitialized	
		}

		errorPrev = error;
		end:								
			if (nEval < evalMax)
				noStop = 0;	// Won't stop
			else
				noStop = 1;	// Will stop

	} // End of "while nostop ...

	//printf("\n 237 modelFunctOptim SW.best %i, size %i",SW.best,SW.P[SW.best].size);
	return SW.P[SW.best];
}
//==============================================================
struct fitness perfModelFunc(struct GammaC G,struct position pos, struct position X[])
{

	double f;
	struct fitness ff={0};
	int i;
	struct vector gammaStar={0};
	struct vector lambda={0};
	int N=G.G.size-1;
	double zz;
//	struct problem dummy; // Just for tests

	// Vecteur of gammax_i,x* 
	// 	printf("\nperfModelFunc 251, N %i",N);
	//gammaStar.size=N+1;
	//printf("\nc %i size %i, %f %f %f %f",G.c.model,G.c.size, G.c.c[0],G.c.c[1],G.c.c[2],G.c.c[3]);
	gammaStar.size=N+1;
	for(i=0;i<N;i++) 
	{
		zz=distanceL(X[i],pos,2);
		gammaStar.v[i]=modelG(zz,G.c);
	}
	gammaStar.v[N]=1;
	//printf("\ngammaStar\n");vectorDisplay(gammaStar);	
	//printf("\nperfModelFunc 262"); printf("\n");
	//printf("\nG");matrixDisplay(G.G);
	// lambda weights for the linear combination	
	lambda=matrixSolve(G.G,gammaStar);
	//printf("\n270 modelFunctOptim lambda:"); vectorDisplay(lambda);	 
	//printf("\nperfModelFunc 265"); printf("\n"); 
	// Estimation of f(x*)

	f=0;
	for(i=0;i<N;i++) f=f+lambda.v[i]*X[i].f.f[0];

	/*
	 // Just to check if the approximation is not too bad
	 dummy.function=0;  // Set it to the right code function
	 zz=perf(pos, dummy, 0,0,0);
	 printf("\n 271 modelFunctOptim f %f, real value %f",f,zz);
	 */
	ff.f[0]=f;
	ff.size=1;
	return ff;
}